jif.ast

## Class DowngradeExpr_c

- java.lang.Object
- - polyglot.ast.Node_c
  - - polyglot.ast.Term_c
    - - polyglot.ast.Expr_c
      - - jif.ast.DowngradeExpr_c

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Cloneable, DowngradeExpr, polyglot.ast.Expr, polyglot.ast.ExprOps, polyglot.ast.Node, polyglot.ast.NodeOps, polyglot.ast.Prefix, polyglot.ast.Receiver, polyglot.ast.Term, polyglot.ast.TermOps, polyglot.ast.Typed, polyglot.util.Copy<polyglot.ast.Node>
  Direct Known Subclasses:
    DeclassifyExpr_c, EndorseExpr_c

      public abstract class DowngradeExpr_c
      extends polyglot.ast.Expr_c
      implements DowngradeExpr

  An implementation of the `DowngradeExpr` interface.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface polyglot.util.Copy

      `polyglot.util.Copy.Util`

    - ### Nested classes/interfaces inherited from interface polyglot.ast.Term

      `polyglot.ast.Term.Instance`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected LabelNode` | `bound`
    `protected polyglot.ast.Expr` | `expr`
    `protected LabelNode` | `label`

    - ### Fields inherited from class polyglot.ast.Expr_c

      `type`

    - ### Fields inherited from class polyglot.ast.Term_c

      `exceptions, reachable`

    - ### Fields inherited from class polyglot.ast.Node_c

      `del, error, ext, position`

    - ### Fields inherited from interface polyglot.ast.Term

      `ENTRY, EXIT`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DowngradeExpr_c(polyglot.util.Position pos, polyglot.ast.Expr expr, LabelNode bound, LabelNode label)` Deprecated.
    `DowngradeExpr_c(polyglot.util.Position pos, polyglot.ast.Expr expr, LabelNode bound, LabelNode label, polyglot.ast.Ext ext)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `<T> java.util.List<T>` | `acceptCFG(polyglot.visit.CFGBuilder<?> v, java.util.List<T> succs)`
    `LabelNode` | `bound()`
    `DowngradeExpr` | `bound(LabelNode b)`
    `protected <N extends DowngradeExpr_c> N` | `bound(N n, LabelNode b)`
    `polyglot.ast.Expr` | `expr()`
    `DowngradeExpr` | `expr(polyglot.ast.Expr expr)`
    `protected <N extends DowngradeExpr_c> N` | `expr(N n, polyglot.ast.Expr expr)`
    `polyglot.ast.Term` | `firstChild()`
    `LabelNode` | `label()`
    `DowngradeExpr` | `label(LabelNode label)`
    `protected <N extends DowngradeExpr_c> N` | `label(N n, LabelNode label)`
    `polyglot.ast.Precedence` | `precedence()`
    `void` | `prettyPrint(polyglot.util.CodeWriter w, polyglot.visit.PrettyPrinter tr)`
    `protected <N extends DowngradeExpr_c> N` | `reconstruct(N n, polyglot.ast.Expr expr, LabelNode bound, LabelNode label)`
    `java.lang.String` | `toString()`
    `void` | `translate(polyglot.util.CodeWriter w, polyglot.visit.Translator tr)`
    `polyglot.ast.Node` | `typeCheck(polyglot.visit.TypeChecker tc)`
    `polyglot.ast.Node` | `visitChildren(polyglot.visit.NodeVisitor v)`

    - ### Methods inherited from class polyglot.ast.Expr_c

      `booleanValue, buildTypes, byteValue, charValue, constantValue, constantValue, constantValueSet, constantValueSet, doubleValue, dump, extRewrite, floatValue, intValue, isConstant, isConstant, isTypeChecked, lastLang, longValue, printSubExpr, printSubExpr, shortValue, stringValue, type, type, type`

    - ### Methods inherited from class polyglot.ast.Term_c

      `exceptionCheck, exceptions, exceptions, exceptions, listChild, reachable, reachable, reachable`

    - ### Methods inherited from class polyglot.ast.Node_c

      `addDecls, buildTypesEnter, checkConstants, childExpectedType, copy, copy, copy, copyIfNeeded, del, del, disambiguate, disambiguateEnter, disambiguateOverride, dump, dump, dump, dump, enterChildScope, enterScope, error, error, error, exceptionCheckEnter, ext, ext, ext, ext, extRewriteEnter, extRewriteOverride, isDisambiguated, lang, position, position, position, prettyPrint, prettyPrint, prettyPrint, prettyPrint, print, printBlock, printSubStmt, throwTypes, typeCheckEnter, typeCheckOverride, visit, visitChild, visitEdge, visitList`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface jif.ast.DowngradeExpr

      `downgradeKind`

    - ### Methods inherited from interface polyglot.ast.Expr

      `constantValue, constantValueSet, isConstant, printSubExpr, printSubExpr, type`

    - ### Methods inherited from interface polyglot.ast.Node

      `del, del, dump, error, error, ext, ext, ext, ext, isDisambiguated, isTypeChecked, position, position, visit, visitEdge`

    - ### Methods inherited from interface polyglot.ast.NodeOps

      `addDecls, buildTypes, buildTypesEnter, checkConstants, childExpectedType, copy, copy, disambiguate, disambiguateEnter, disambiguateOverride, dump, dump, dump, dump, enterChildScope, enterScope, exceptionCheck, exceptionCheckEnter, extRewrite, extRewriteEnter, extRewriteOverride, lang, prettyPrint, prettyPrint, prettyPrint, prettyPrint, throwTypes, typeCheckEnter, typeCheckOverride, visitChild, visitList`

    - ### Methods inherited from interface polyglot.util.Copy

      `copy`

    - ### Methods inherited from interface polyglot.ast.Typed

      `type`

    - ### Methods inherited from interface polyglot.ast.Term

      `exceptions, exceptions, reachable, reachable`

- - ### Field Detail

    - #### label

          protected LabelNode label

    - #### bound

          protected LabelNode bound

    - #### expr

          protected polyglot.ast.Expr expr

  - ### Constructor Detail

    - #### DowngradeExpr_c

          @Deprecated
          public DowngradeExpr_c(polyglot.util.Position pos,
                                             polyglot.ast.Expr expr,
                                             LabelNode bound,
                                             LabelNode label)

      Deprecated.

    - #### DowngradeExpr_c

          public DowngradeExpr_c(polyglot.util.Position pos,
                                 polyglot.ast.Expr expr,
                                 LabelNode bound,
                                 LabelNode label,
                                 polyglot.ast.Ext ext)

  - ### Method Detail

    - #### expr

          public polyglot.ast.Expr expr()

      Specified by:
        `expr` in interface `DowngradeExpr`

    - #### expr

          public DowngradeExpr expr(polyglot.ast.Expr expr)

      Specified by:
        `expr` in interface `DowngradeExpr`

    - #### expr

          protected <N extends DowngradeExpr_c> N expr(N n,
                                                       polyglot.ast.Expr expr)

    - #### label

          public LabelNode label()

      Specified by:
        `label` in interface `DowngradeExpr`

    - #### label

          public DowngradeExpr label(LabelNode label)

      Specified by:
        `label` in interface `DowngradeExpr`

    - #### label

          protected <N extends DowngradeExpr_c> N label(N n,
                                                        LabelNode label)

    - #### bound

          public LabelNode bound()

      Specified by:
        `bound` in interface `DowngradeExpr`

    - #### bound

          public DowngradeExpr bound(LabelNode b)

      Specified by:
        `bound` in interface `DowngradeExpr`

    - #### bound

          protected <N extends DowngradeExpr_c> N bound(N n,
                                                        LabelNode b)

    - #### reconstruct

          protected <N extends DowngradeExpr_c> N reconstruct(N n,
                                                              polyglot.ast.Expr expr,
                                                              LabelNode bound,
                                                              LabelNode label)

    - #### visitChildren

          public polyglot.ast.Node visitChildren(polyglot.visit.NodeVisitor v)

      Specified by:
        `visitChildren` in interface `polyglot.ast.NodeOps`
      Overrides:
        `visitChildren` in class `polyglot.ast.Node_c`

    - #### typeCheck

          public polyglot.ast.Node typeCheck(polyglot.visit.TypeChecker tc)

      Specified by:
        `typeCheck` in interface `polyglot.ast.NodeOps`
      Overrides:
        `typeCheck` in class `polyglot.ast.Node_c`

    - #### firstChild

          public polyglot.ast.Term firstChild()

      Specified by:
        `firstChild` in interface `polyglot.ast.TermOps`
      Specified by:
        `firstChild` in class `polyglot.ast.Term_c`

    - #### acceptCFG

          public <T> java.util.List<T> acceptCFG(polyglot.visit.CFGBuilder<?> v,
                                                 java.util.List<T> succs)

      Specified by:
        `acceptCFG` in interface `polyglot.ast.TermOps`
      Specified by:
        `acceptCFG` in class `polyglot.ast.Term_c`

    - #### prettyPrint

          public void prettyPrint(polyglot.util.CodeWriter w,
                                  polyglot.visit.PrettyPrinter tr)

      Specified by:
        `prettyPrint` in interface `polyglot.ast.NodeOps`
      Overrides:
        `prettyPrint` in class `polyglot.ast.Node_c`

    - #### translate

          public void translate(polyglot.util.CodeWriter w,
                                polyglot.visit.Translator tr)

      Specified by:
        `translate` in interface `polyglot.ast.NodeOps`
      Overrides:
        `translate` in class `polyglot.ast.Node_c`

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `polyglot.ast.Node_c`

    - #### precedence

          public polyglot.ast.Precedence precedence()

      Specified by:
        `precedence` in interface `polyglot.ast.Expr`
      Overrides:
        `precedence` in class `polyglot.ast.Expr_c`